package ru.somecompany;

import com.rabbitmq.client.Channel;
import com.rabbitmq.client.Connection;
import com.rabbitmq.client.ConnectionFactory;
import com.rabbitmq.client.DeliverCallback;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.concurrent.TimeoutException;

public class Main {

    private static final String QUEUE_NAME = "hello-world";

    public static void main(String[] args) {
        ConnectionFactory factory = new ConnectionFactory();
        factory.setHost("localhost");
        try(Connection connection = factory.newConnection();
            Channel channel = connection.createChannel();) {
            var sender = new Sender(channel);
            var receiver = new Receiver(channel);

        } catch (Exception e) {
            System.out.println(" [*] Error in Hello-World");
        }
    }
}