package ru.somecompany.scheduler;

import com.rabbitmq.client.BuiltinExchangeType;
import com.rabbitmq.client.Channel;
import com.rabbitmq.client.Connection;
import com.rabbitmq.client.ConnectionFactory;
import lombok.RequiredArgsConstructor;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.concurrent.TimeoutException;

@Service
@RequiredArgsConstructor
public class SenderScheduler {

    private static final String EXCHANGE_NAME = "order-events";
    private static final String MESSAGE = "Поступил заказ №%d";
    private Integer index = 0;

    private final ConnectionFactory connectionFactory;
    private final Connection connection;
    private final Channel channel;

    @Scheduled(cron = "*/1 * * * * *")
    public void sendMessage() {
        try  {
            var message = String.format(MESSAGE, index);

            channel.basicPublish(EXCHANGE_NAME, "", null, message.getBytes(StandardCharsets.UTF_8));
            index++;
            System.out.println(" [x] Sent '" + message + "'");
        } catch (IOException e) {
            System.out.println(" [x] Error while send message");
            throw new RuntimeException(e);
        }
    }

}
