package ru.somecompany;

import com.rabbitmq.client.Channel;
import com.rabbitmq.client.Connection;
import com.rabbitmq.client.ConnectionFactory;

public class Main {

    public static final String QUEUE_NAME = "task_queue";

    public static void main(String[] args) {
        ConnectionFactory factory = new ConnectionFactory();
        factory.setHost("localhost");
        try(Connection connection = factory.newConnection();
            Channel channel = connection.createChannel();) {
            var sender = new Sender(channel);
            sender.send("Work Queue message");
            var receiver = new Receiver(channel);
        } catch (Exception e) {
            System.out.println(" [*] Error in Work-Queue: " + e.getMessage());
        }
    }
}