package ru.somecompany;

import com.rabbitmq.client.Channel;
import com.rabbitmq.client.MessageProperties;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.nio.charset.StandardCharsets;

import static ru.somecompany.Main.QUEUE_NAME;

public class Sender {

    private Channel channel;

    public Sender(Channel channel) throws IOException {
        channel.queueDeclare(QUEUE_NAME, true, false, false, null);
        this.channel = channel;
    }

    public void send(String msg) throws IOException {
        String message = String.join(" ", msg);

        channel.basicPublish("", QUEUE_NAME,
                MessageProperties.PERSISTENT_TEXT_PLAIN,
                message.getBytes("UTF-8"));
        System.out.println(" [x] Sent '" + message + "'");
    }
}
